function [out1,out2,out3,out4,out5] = sto1welfmodel(flag,s,x,z,e,snext,xnext,p,output)

voidcell                   = cell(1,5);
[out1,out2,out3,out4,out5] = voidcell{:};

switch flag

  case 'b'
    n = size(s,1);
    out1 = -inf(n,6);
    out1(:,1) = 0;
    out2 = inf(n,6);

  case 'f'
    n = size(s,1);

    % f
    if output.F
      out1 = zeros(n,6);
      out1(:,1) = p(1) - z(:,1).*(-p(2) + 1)./(p(3) + 1) + x(:,3);
      out1(:,2) = -p(4).*x(:,2).^p(5) + z(:,2)./(p(3) + 1);
      out1(:,3) = s(:,1) - x(:,3).^p(6) - x(:,1);
      out1(:,4) = p(4).*x(:,2).^(p(5) + 1)./(p(5) + 1) - s(:,1).*x(:,3) - z(:,3)./(p(3) + 1) + x(:,3).^(p(6) + 1)./(p(6) + 1) + x(:,1).*(p(1) + x(:,3)) + x(:,4);
      out1(:,5) = -z(:,4)./(p(3) + 1) + x(:,3).^(p(6) + 1)./(p(6) + 1) + x(:,5);
      out1(:,6) = p(4).*x(:,2).^(p(5) + 1)./(p(5) + 1) - z(:,2).*x(:,2)./(p(3) + 1) - z(:,5)./(p(3) + 1) + x(:,6);
    end

    % df/ds
    if output.Js
      out2 = zeros(n,6,1);
      out2(:,3,1) = 1; % d eq_3 w.r.t. A
      out2(:,4,1) = -x(:,3); % d eq_4 w.r.t. A
    end

    % df/dx
    if output.Jx
      out3 = zeros(n,6,6);
      out3(:,1,3) = 1; % d eq_1 w.r.t. P
      out3(:,2,2) = -p(4).*p(5).*x(:,2).^p(5)./x(:,2); % d eq_2 w.r.t. H
      out3(:,3,1) = -1; % d eq_3 w.r.t. S
      out3(:,3,3) = -p(6).*x(:,3).^p(6)./x(:,3); % d eq_3 w.r.t. P
      out3(:,4,1) = p(1) + x(:,3); % d eq_4 w.r.t. S
      out3(:,4,2) = p(4).*x(:,2).^(p(5) + 1)./x(:,2); % d eq_4 w.r.t. H
      out3(:,4,3) = -s(:,1) + x(:,1) + x(:,3).^(p(6) + 1)./x(:,3); % d eq_4 w.r.t. P
      out3(:,4,4) = 1; % d eq_4 w.r.t. W
      out3(:,5,3) = x(:,3).^(p(6) + 1)./x(:,3); % d eq_5 w.r.t. P
      out3(:,5,5) = 1; % d eq_5 w.r.t. Wc
      out3(:,6,2) = p(4).*x(:,2).^(p(5) + 1)./x(:,2) - z(:,2)./(p(3) + 1); % d eq_6 w.r.t. H
      out3(:,6,6) = 1; % d eq_6 w.r.t. Wp
    end

    % df/dz
    if output.Jz
      out4 = zeros(n,6,5);
      out4(:,1,1) = -(-p(2) + 1)./(p(3) + 1); % d eq_1 w.r.t. EP
      out4(:,2,2) = 1./(p(3) + 1); % d eq_2 w.r.t. EPe
      out4(:,4,3) = -1./(p(3) + 1); % d eq_4 w.r.t. EW
      out4(:,5,4) = -1./(p(3) + 1); % d eq_5 w.r.t. EWc
      out4(:,6,2) = -x(:,2)./(p(3) + 1); % d eq_6 w.r.t. EPe
      out4(:,6,5) = -1./(p(3) + 1); % d eq_6 w.r.t. EWp
    end
  
  case 'g'
    n = size(s,1);

    % g
    if output.F
      out1 = zeros(n,1);
      out1(:,1) = e(:,1).*x(:,2) + x(:,1).*(-p(2) + 1);      
    end

    if output.Js
      out2 = zeros(n,1,1);
    end

    if output.Jx
      out3 = zeros(n,1,6);
      out3(:,1,1) = -p(2) + 1; % d eq_1 w.r.t. S
      out3(:,1,2) = e(:,1); % d eq_1 w.r.t. H
    end
  
  case 'h'
    n = size(snext,1);

    %h
    if output.F
      out1 = zeros(n,5);
      out1(:,1) = xnext(:,3);
      out1(:,2) = e(:,1).*xnext(:,3);
      out1(:,3) = xnext(:,4);
      out1(:,4) = xnext(:,5);
      out1(:,5) = xnext(:,6);
    end

    if output.Js
      out2 = zeros(n,5,1);
    end

    if output.Jx
      out3 = zeros(n,5,6);
    end

    if output.Jsn
      out4 = zeros(n,5,1);
    end

    if output.Jxn
      out5 = zeros(n,5,6);
      out5(:,1,3) = 1; % d eq_1 w.r.t. P(1)
      out5(:,2,3) = e(:,1); % d eq_2 w.r.t. P(1)
      out5(:,3,4) = 1; % d eq_3 w.r.t. W(1)
      out5(:,4,5) = 1; % d eq_4 w.r.t. Wc(1)
      out5(:,5,6) = 1; % d eq_5 w.r.t. Wp(1)
    end
  
  case 'e'
    out1 = [];

  case 'params'
    out1 = [ 0.06        0.02        0.03        0.97087379  5.         -0.2         0.2       ];

  case 'ss'
    out1 = [1.0];
    out2 = [0.0  1.0  1.0  -14.1388888889  -42.9166666667  27.7777777778];

  case 'J'
    out1.fs = [0; 0; 1; 1; 0; 0];
    out1.fx = [0 0 1 0 0 0; 0 1 0 0 0 0; 1 0 1 0 0 0; 1 1 1 1 0 0; 0 0 1 0 1 0; 0 1 0 0 0 1];
    out1.fz = [1 0 0 0 0; 0 1 0 0 0; 0 0 0 0 0; 0 0 1 0 0; 0 0 0 1 0; 0 1 0 0 1];
    out1.gs = [0];
    out1.gx = [1 1 0 0 0 0];
    out1.hs = [0; 0; 0; 0; 0];
    out1.hx = [0 0 0 0 0 0; 0 0 0 0 0 0; 0 0 0 0 0 0; 0 0 0 0 0 0; 0 0 0 0 0 0];
    out1.hsnext = [0; 0; 0; 0; 0];
    out1.hxnext = [0 0 1 0 0 0; 0 0 1 0 0 0; 0 0 0 1 0 0; 0 0 0 0 1 0; 0 0 0 0 0 1];

end