%% STO6MENA Two-country storage-trade model (MENA application)

%% Pack model structure
Mu                = [1 1];
sigma             = [0.07 0;
                     0    0.03];
model = recsmodelinit('sto6MENA.yaml',struct('Mu',Mu,'Sigma',sigma^2,'order',7));

%% Define approximation space
[interp,s] = recsinterpinit(25,[0.65 0.75].*model.sss,1.4*model.sss);

%% Find a first guess through the perfect foresight solution
interp = recsFirstGuess(interp,model,s,model.sss,model.xss,5);

%% Solve for rational expectations
[interp,x] = recsSolveREE(interp,model,s);

%% Simulate the model
[~,~,~,~,stat] = recsSimul(model,interp,model.sss(ones(1E4,1),:),100);


