function [out1,out2,out3,out4,out5] = sto6MENAmodel(flag,s,x,z,e,snext,xnext,p,output)

voidcell                   = cell(1,5);
[out1,out2,out3,out4,out5] = voidcell{:};

switch flag

  case 'b'
    n = size(s,1);
    out1 = -inf(n,8);
    out1(:,1) = 0;
    out1(:,2) = 0;
    out1(:,7) = 0;
    out1(:,8) = 0;
    out2 = inf(n,8);

  case 'f'
    n = size(s,1);

    % f
    if output.F
      out1 = zeros(n,8);
      out1(:,1) = p(1) - z(:,1).*(-p(3) + 1)./(p(2) + 1) + x(:,5);
      out1(:,2) = p(1) - z(:,2).*(-p(3) + 1)./(p(2) + 1) + x(:,6);
      out1(:,3) = -p(4).*x(:,3).^p(6) + z(:,3)./(p(2) + 1);
      out1(:,4) = -p(5).*x(:,4).^p(6) + z(:,4)./(p(2) + 1);
      out1(:,5) = -p(10).*x(:,5).^p(9) + s(:,1) - x(:,1) - x(:,7) + x(:,8);
      out1(:,6) = -p(11).*x(:,6).^p(9) + s(:,2) - x(:,2) + x(:,7) - x(:,8);
      out1(:,7) = p(8) + x(:,5) - x(:,6);
      out1(:,8) = p(8) - x(:,5) + x(:,6);
    end

    % df/ds
    if output.Js
      out2 = zeros(n,8,2);
      out2(:,5,1) = 1; % d eq_5 w.r.t. Aa
      out2(:,6,2) = 1; % d eq_6 w.r.t. Ab
    end

    % df/dx
    if output.Jx
      out3 = zeros(n,8,8);
      out3(:,1,5) = 1; % d eq_1 w.r.t. Pa
      out3(:,2,6) = 1; % d eq_2 w.r.t. Pb
      out3(:,3,3) = -p(4).*p(6).*x(:,3).^p(6)./x(:,3); % d eq_3 w.r.t. Ha
      out3(:,4,4) = -p(5).*p(6).*x(:,4).^p(6)./x(:,4); % d eq_4 w.r.t. Hb
      out3(:,5,1) = -1; % d eq_5 w.r.t. Sa
      out3(:,5,5) = -p(9).*p(10).*x(:,5).^p(9)./x(:,5); % d eq_5 w.r.t. Pa
      out3(:,5,7) = -1; % d eq_5 w.r.t. Xa
      out3(:,5,8) = 1; % d eq_5 w.r.t. Xb
      out3(:,6,2) = -1; % d eq_6 w.r.t. Sb
      out3(:,6,6) = -p(9).*p(11).*x(:,6).^p(9)./x(:,6); % d eq_6 w.r.t. Pb
      out3(:,6,7) = 1; % d eq_6 w.r.t. Xa
      out3(:,6,8) = -1; % d eq_6 w.r.t. Xb
      out3(:,7,5) = 1; % d eq_7 w.r.t. Pa
      out3(:,7,6) = -1; % d eq_7 w.r.t. Pb
      out3(:,8,5) = -1; % d eq_8 w.r.t. Pa
      out3(:,8,6) = 1; % d eq_8 w.r.t. Pb
    end

    % df/dz
    if output.Jz
      out4 = zeros(n,8,4);
      out4(:,1,1) = -(-p(3) + 1)./(p(2) + 1); % d eq_1 w.r.t. EPa
      out4(:,2,2) = -(-p(3) + 1)./(p(2) + 1); % d eq_2 w.r.t. EPb
      out4(:,3,3) = 1./(p(2) + 1); % d eq_3 w.r.t. EPea
      out4(:,4,4) = 1./(p(2) + 1); % d eq_4 w.r.t. EPeb
    end
  
  case 'g'
    n = size(s,1);

    % g
    if output.F
      out1 = zeros(n,2);
      out1(:,1) = e(:,1).*x(:,3) + x(:,1).*(-p(3) + 1);
      out1(:,2) = e(:,2).*x(:,4) + x(:,2).*(-p(3) + 1);      
    end

    if output.Js
      out2 = zeros(n,2,2);
    end

    if output.Jx
      out3 = zeros(n,2,8);
      out3(:,1,1) = -p(3) + 1; % d eq_1 w.r.t. Sa
      out3(:,1,3) = e(:,1); % d eq_1 w.r.t. Ha
      out3(:,2,2) = -p(3) + 1; % d eq_2 w.r.t. Sb
      out3(:,2,4) = e(:,2); % d eq_2 w.r.t. Hb
    end
  
  case 'h'
    n = size(snext,1);

    %h
    if output.F
      out1 = zeros(n,4);
      out1(:,1) = xnext(:,5);
      out1(:,2) = xnext(:,6);
      out1(:,3) = e(:,1).*xnext(:,5);
      out1(:,4) = e(:,2).*xnext(:,6);
    end

    if output.Js
      out2 = zeros(n,4,2);
    end

    if output.Jx
      out3 = zeros(n,4,8);
    end

    if output.Jsn
      out4 = zeros(n,4,2);
    end

    if output.Jxn
      out5 = zeros(n,4,8);
      out5(:,1,5) = 1; % d eq_1 w.r.t. Pa(1)
      out5(:,2,6) = 1; % d eq_2 w.r.t. Pb(1)
      out5(:,3,5) = e(:,1); % d eq_3 w.r.t. Pa(1)
      out5(:,4,6) = e(:,2); % d eq_4 w.r.t. Pb(1)
    end
  
  case 'e'
    out1 = [];

  case 'params'
    out1 = [  2.24000000e+01   5.00000000e-02   0.00000000e+00   1.91908170e-06   1.71603108e-12   5.00000000e+00   2.00000000e-01   3.55500000e+01  -1.20000000e-01   1.43167532e+02   1.10266343e+03   9.52380952e-01];

  case 'ss'
    out1 = [40.2  628.0];
    out2 = [0.0  0.0  40.2  628.0  211.55  176.0  0.0  35.1];

  case 'J'
    out1.fs = [0 0; 0 0; 0 0; 0 0; 1 0; 0 1; 0 0; 0 0];
    out1.fx = [0 0 0 0 1 0 0 0; 0 0 0 0 0 1 0 0; 0 0 1 0 0 0 0 0; 0 0 0 1 0 0 0 0; 1 0 0 0 1 0 1 1; 0 1 0 0 0 1 1 1; 0 0 0 0 1 1 0 0; 0 0 0 0 1 1 0 0];
    out1.fz = [1 0 0 0; 0 1 0 0; 0 0 1 0; 0 0 0 1; 0 0 0 0; 0 0 0 0; 0 0 0 0; 0 0 0 0];
    out1.gs = [0 0; 0 0];
    out1.gx = [1 0 1 0 0 0 0 0; 0 1 0 1 0 0 0 0];
    out1.hs = [0 0; 0 0; 0 0; 0 0];
    out1.hx = [0 0 0 0 0 0 0 0; 0 0 0 0 0 0 0 0; 0 0 0 0 0 0 0 0; 0 0 0 0 0 0 0 0];
    out1.hsnext = [0 0; 0 0; 0 0; 0 0];
    out1.hxnext = [0 0 0 0 1 0 0 0; 0 0 0 0 0 1 0 0; 0 0 0 0 1 0 0 0; 0 0 0 0 0 1 0 0];

end